/*******************************************************************************
*   $FILE: SPI_Master.c
*   Atmel Corporation: http://www.atmel.com \n
*   xEҰ: touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/

/*============================ ݸٰ =======================================*/
#include "touch.h"

#if defined(_DEBUG_INTERFACE_) && defined(QDEBUG_SPI)
#include "avr_compiler.h"
#include "SPI_Master.h"
#include "QDebugTransport.h"

/*============================  ==========================================*/
#define JOIN1( A, B, C ) A ## B ## C
#define CONCAT( A, B, C ) JOIN1( A, B, C )
/*============================================================================
O: SPI_Master_Init
------------------------------------------------------------------------------
ړI: SPI̪
: Ȃ
o: Ȃ
: QDebug.cQDebug_InitĂ΂܂B
============================================================================*/
void SPI_Master_Init (void)
{
	// MOSI,SCK,SS͏óAMISOٱ
//	SPI_DDR |= (1<<SS) | (1<<MOSI) | (1<<SCK);
	CONCAT( PORT, SPI_SS, _DIR) =  (1<<SS) | (1<<MOSI) | (1<<SCK);
//	SPI_DDR &=~(1<<MISO);
	CONCAT( PORT, SPI_SS, _DIR) &=~(1<<MISO);
//	SPI_PORT &=~ ((1<<SS) | (1<<SCK) | (1<<MOSI)) ;
	CONCAT( PORT, SPI_SS, _OUT)  &=~ ((1<<SS) | (1<<SCK) | (1<<MOSI));
//	SPI_PORT |= (1<<MISO);
	CONCAT( PORT, SPI_SS, _OUT) |= (1<<MISO);
	SPIC_CTRL = (1<<SPI_ENABLE_bp) | (1<<SPI_MASTER_bp) |
		(0<<SPI_PRESCALER1_bp)|(1<<SPI_PRESCALER0_bp);
}

/*============================================================================
O: SPI_Send_Byte
------------------------------------------------------------------------------
ړI: SPI̪gp1޲đM
: ]u֑ް
o: ]uǂް
: ̧ٓSPI_Send_MessageĂ΂܂B
============================================================================*/
uint8_t SPI_Send_Byte (uint8_t c)
{
	uint8_t data;

	SPIC_DATA = c;								// SPIްMJn
	while (!(SPIC_STATUS & (1<<SPI_IF_bp)));	// ޲đMҋ@
	data = SPIC_DATA;							// Mް擾
	delay_us(50);
	return data;
}

/*============================================================================
O: SPI_Send_Message
------------------------------------------------------------------------------
ړI: SPI̪gp1ڰёM
: Ȃ
o: Ȃ
: QDebugTransport.cSend_MessageĂ΂܂B
============================================================================*/
void SPI_Send_Message (void)
{
	unsigned int i;
	volatile uint8_t FrameInProgress;

	// үޑo
	for (i=0; i <= TX_index; i++)
	{
		FrameInProgress = RxHandler(SPI_Send_Byte(TX_Buffer[i]));
	}
	// ޲ĎMKv?
	while (FrameInProgress)
		FrameInProgress = RxHandler(SPI_Send_Byte(0));
}
#endif
