/*******************************************************************************
*   $FILE:  main.c
*   Atmel Corporation: http://www.atmel.com \n
*   xEҰ: touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/

/*----------------------------------------------------------------------------
								  ߲׏
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								 ݸٰ ̧
----------------------------------------------------------------------------*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include "touch.h"
#include "touch_api.h"
/*----------------------------------------------------------------------------
								  Ȓ萔
----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------
									^`
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									 ^
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								  \̐錾
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									 ϸ
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								   Sϐ
----------------------------------------------------------------------------*/
/* msł̌v */
extern uint16_t qt_measurement_period_msec;

/*----------------------------------------------------------------------------
								   Oϐ
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								   ÓIϐ
----------------------------------------------------------------------------*/

/* ڐG̎Ԃ̎ɌvɂĐݒ肳׸ */
extern volatile uint8_t time_to_measure_touch;

/* vISRɂĐݒ肳錻݂̎ */
extern volatile uint16_t current_time_ms_touch;

#if defined(__ATxmega128A1__)
/*============================================================================
O: init_timer_isr
------------------------------------------------------------------------------
ړI: Iɔ悤ɌvISR`Ԑݒ
============================================================================*/

void init_timer_isr (void)
{
	TCC0.PER = TICKS_PER_MS * qt_measurement_period_msec;	/* vݒ */
	TCC0.CTRLA = (TOUCH_DATA_T)4;							/* ۯI */
	TCC0.INTCTRLB = 1u;										/* rA荞݂ʂɐݒ */
	PMIC.CTRL |= 1u;										/* i荞ݐŒʊ荞݂ */
}
/*============================================================================
O: set_timer_period
------------------------------------------------------------------------------
ړI: svύX
: qt_measurement_period_msec
o: Ȃ
:
============================================================================*/
void set_timer_period (uint16_t qt_measurement_period_msec)
{
	/* vrlݒ(vISRpxA1ms荞݂ɐݒ) */
	TCC0.PER = TICKS_PER_MS * qt_measurement_period_msec;
}

/*============================================================================
O: ،ŏꂽCCPݕ⏕֐
------------------------------------------------------------------------------
ړI: ̊֐XMEGApڼ޽ւ̎Ԃdvȏݑ̂߂ɱ،ŏ
	  ܂B
: address - ڽւ߲
	  value   - ڼ޽֒ul
============================================================================*/
void CCPWrite (volatile uint8_t * address, uint8_t value)
{
	volatile uint8_t * tmpAddr = address;
#ifdef RAMPZ
	RAMPZ = 0;
#endif
	asm volatile(
				"MOVW R30, %0"	"\n\t"
				"LDI  R16, %2"	"\n\t"
				"OUT   %3,R16"	"\n\t"
				"ST     Z, %1"
				:
				: "R" (tmpAddr), "R" (value), "M" (CCP_IOREG_gc), "m" (CCP)
				: "R16", "R30", "R31"
				);
}

/*============================================================================
O: init_system
------------------------------------------------------------------------------
ړI: νĉpA݁AޯނȂǏ
============================================================================*/
void init_system (void)
{
	uint8_t PSconfig;
	uint8_t clkCtrl;

	/* UƸۯ`Ԑݒ */

	/* OuA4AOuBCeX11ƂđI */
	/* ŚAA~B~C4 */
	PSconfig = (uint8_t) CLK_PSADIV_4_gc | CLK_PSBCDIV_1_1_gc;
	OSC.CTRL |= OSC_RC32MEN_bm;							/* 32MHz󔭐U틖 */
	CCPWrite( &CLK.PSCTRL, PSconfig );
	while ( ( OSC.STATUS & OSC_RC32MRDY_bm ) == 0 );	/* U폀܂őҋ@ */
	clkCtrl = ( CLK.CTRL & ~CLK_SCLKSEL_gm ) | CLK_SCLKSEL_RC32M_gc;	/* ۯƂ32MHz󔭐Uݒ */
	CCPWrite( &CLK.CTRL, clkCtrl );

	/* ۯM߰ ݂֔z */
	/* PORTCFG_CLKEVOUT = 0x03; */
	/* PORTE_DIRSET = 0x80; */

}

ISR(TCC0_CCA_vect)
{
	time_to_measure_touch = 1u;								/* ׸ސݒ:͐ڐG𑪒肷鎞łB */
	current_time_ms_touch += qt_measurement_period_msec;	/* ݂̎ԂXV */
}
#endif
