/* ̿ ̧قATMEL QTouchײ،J4.3.1̈ꕔłB */
/* ̧قDoxygenpɏĂ܂B */
/*! \file *********************************************************************
 *
 * \brief ̧قAVR 8ޯQTouch@eʐڐG̎pQTouchײ،`ԐݒCӑI
 *		  ܂݂܂B
 *
 * - ߲			: AVRpIAR EWAVRGNU GCC
 * - x޲		: ATMEL AVR 8ޯ
 * - gp҂̎	: QTouchײ؎gp҂̎ - doc8207.pdf
 * - xEҰ		: touch@atmel.com
 *
 * \author Atmel Corporation	: http://www.atmel.com \n
 *		   xFAQ			: http://support.atmel.no/
 *
 ******************************************************************************/

/* 쌠 (c) 2010, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef _QT_ASM_AVR_H_
#define _QT_ASM_AVR_H_

#include "touch.h"

/**
  * x:̍s̺̉ނ̂ǂ̕ύXȂłB
  */
#if (QT_DELAY_CYCLES == 0)
  #error 'QT_DELAY_CYCLES can only have values in the range 1-255.'
#endif

#if !(defined(__AVR32__) || defined(__ICCAVR32__))
  #if ((QT_NUM_CHANNELS == 8) || (QT_NUM_CHANNELS == 4))

	#ifdef QTOUCH_STUDIO_MASKS
	  #define QTOUCH_PIN_CONF			1
	  #define _STATIC_PORT_PIN_CONF_	1
	#else
	  #define QTOUCH_PIN_CONF			0
	  #define _STATIC_PORT_PIN_CONF_	0
	#endif

	#ifdef _SNS1_SNSK1_SAME_PORT_
	  #define _STATIC_PORT_PIN_CONF_	1
	  #define INTRABURST_1				1

	  #if (QT_NUM_CHANNELS == 4)
		#define QTOUCH_SNS_PORT_COUNT	1
		#define INTRABURST_2			0
	  #elif (QT_NUM_CHANNELS == 8)
		#define QTOUCH_SNS_PORT_COUNT	2
		#define INTRABURST_2			1
	  #endif
	#else

	  #define QTOUCH_SNS_PORT_COUNT		1
	  #define INTRABURST_1				0
	  #define INTRABURST_2				0
	#endif
  #elif ((QT_NUM_CHANNELS == 16) || (QT_NUM_CHANNELS == 12))
	#define _STATIC_PORT_PIN_CONF_		1
	#define QTOUCH_SNS_PORT_COUNT		2

	#ifdef QTOUCH_STUDIO_MASKS
	  #define QTOUCH_PIN_CONF			1
	#else
	  #define QTOUCH_PIN_CONF			0
	#endif

	#ifdef _SNS1_SNSK1_SAME_PORT_
	  #define INTRABURST_1				1
	#else
	  #define INTRABURST_1				0
	#endif

	#ifdef _SNS2_SNSK2_SAME_PORT_
	  #define INTRABURST_2				1
	#else
	  #define INTRABURST_2				0
	#endif

	#if ((INTRABURST_1== 1) && (INTRABURST_2== 1))
	  #error 'QT_NUM_CHANNELS value should be 8 in this case.'
	#elif ((INTRABURST_1== 1) || (INTRABURST_2== 1))
	  #if (QT_NUM_CHANNELS == 16)
		#error 'QT_NUM_CHANNELS value should be 12 in this case.'
	  #endif
	#elif ((INTRABURST_1== 0) && (INTRABURST_2== 0))
	  #if (QT_NUM_CHANNELS == 12)
		#error 'QT_NUM_CHANNELS value should be 16 in this case.'
	  #endif
	#endif
  #elif (QT_NUM_CHANNELS == 32)
	#define _STATIC_PORT_PIN_CONF_		1
	#define QTOUCH_SNS_PORT_COUNT		2
	#define QTOUCH_PIN_CONF				0
	#ifdef _SNS1_SNSK1_SAME_PORT_
	  #define INTRABURST_1				1
	#else
	  #define INTRABURST_1				0
	#endif

	#ifdef _SNS2_SNSK2_SAME_PORT_
	  #define INTRABURST_2				1
	#else
	  #define INTRABURST_2				0
	#endif
  #else
	#error 'QT_NUM_CHANNELS specified is not supported.'
  #endif
#else
  #ifdef _SNS1_SNSK1_SAME_PORT_
	#define _STATIC_PORT_PIN_CONF_		1
	#define QTOUCH_SNS_PORT_COUNT		1
	#define INTRABURST_1				1
	#define INTRABURST_2				0
  #else
	#define _STATIC_PORT_PIN_CONF_		0
	#define QTOUCH_SNS_PORT_COUNT		1
	#define INTRABURST_1				0
	#define INTRABURST_2				0
  #endif
#endif

#if (defined(__IAR_SYSTEMS_ASM__) || defined(__ASSEMBLER__) || defined(__ICCAVR32__) || defined(__AVR32__))
  #if (defined(__IAR_SYSTEMS_ASM__) || defined(__ICCAVR32__))
	#if defined(__IAR_SYSTEMS_ASM__)
	  #include <ioavr.h>
	  #define p_1						R16
	  #define p_2						R17
	  #define p_3						R18
	  #define p_4						R19
	  #define p_5						R20
	  #define r_v						R16
	  #define FILE_HEADER		NAME	qt_asm_iar
	  #define FILE_FOOTER		END
	  #define FILE_SEGMENT		RSEG	CODE
	  #define GLOBAL_FUNCTION	PUBLIC

	  #define GLOBAL_VAR EQU
	#elif defined(__ICCAVR32__)
	  #include <avr32/io.h>
	  #define p_1						R12
	  #define p_2						R11
	  #define p_3						R10
	  #define r_v						R12
	  #define _UC3A_

	  #define _QTOUCH_
//	  #define FILE_HEADER		NAME	qt_asm_iar
//	  #define FILE_FOOTER		END
//	  #define FILE_SEGMENT		RSEG	CODE
	  #define FILE_HEADER
	  #define FILE_FOOTER
	  #define FILE_SEGMENT
	  #define GLOBAL_FUNCTION	PUBLIC
	#endif
  #elif (defined(__ASSEMBLER__) || defined(__AVR32__))
	#if defined(__AVR32__)
	  #include <avr32/io.h>

	  #define p_1						R12
	  #define p_2						R11
	  #define p_3						R10
	  #define r_v						R12

	  #define _QTOUCH_
	  #define _UC3A_
	  #define _STATIC_PORT_PIN_CONF_	0
	  #define QTOUCH_SNS_PORT_COUNT		1
	  #define INTRABURST_1				0
	  #define INTRABURST_2				0
	#else
	  #define __SFR_OFFSET				0
	  #include <avr/io.h>
	  #define p_1						R24
	  #define p_2						R22
	  #define p_3						R20
	  #define p_4						R18
	  #define p_5						R16
	  #define r_v						R24

	  #define GLOBAL_VAR				.EQU
	#endif

	#define FILE_HEADER
	#define FILE_FOOTER
	#define FILE_SEGMENT
	#define GLOBAL_FUNCTION				.global
  #else
	#error 'Assembler not supported.'
  #endif

  #define JOIN( x, y ) x ## y
  #define JOIN1( A, B, C ) A ## B ## C
  #define REG( REGISTER, SIDE ) JOIN( REGISTER, SIDE )
  #define CONCAT( A, B, C ) JOIN1( A, B, C )

  #define sreg_save r2

  #define _00011001_					NOP
  #define _01101001_					BRNE _111_
  #define _01101011_					BRNE _222_
  #define _10001110_					RJMP .
  #if (defined (__AVR32__) || defined (__ICCAVR32__))
    #define _10100011_					_111_: SUB R9,1
    #define _10100111_					_222_: SUB R9,1
    #define _11100011_					MOV R9,((QT_DELAY_CYCLES - 1)/3)
  #else
    #define _10100011_					_111_: DEC R19
    #define _10100111_					_222_: DEC R19
    #define _11100011_					LDI R19,((QT_DELAY_CYCLES - 1)/3)
  #endif

#else

  #ifndef _QTOUCH_
	#define _QTOUCH_
  #endif
#endif

#endif /*_QT_ASM_AVR8_H_*/
